/* Client.c generated by valac 0.34.7, the Vala compiler
 * generated from Client.vala, do not modify */

/**/
/*  Copyright (C) 2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define PLANK_TYPE_DBUS_CLIENT (plank_dbus_client_get_type ())
#define PLANK_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DBUS_CLIENT, PlankDBusClient))
#define PLANK_DBUS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_DBUS_CLIENT, PlankDBusClientClass))
#define PLANK_IS_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DBUS_CLIENT))
#define PLANK_IS_DBUS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_DBUS_CLIENT))
#define PLANK_DBUS_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_DBUS_CLIENT, PlankDBusClientClass))

typedef struct _PlankDBusClient PlankDBusClient;
typedef struct _PlankDBusClientClass PlankDBusClientClass;
typedef struct _PlankDBusClientPrivate PlankDBusClientPrivate;

#define PLANK_TYPE_DBUS_ITEMS_IFACE (plank_dbus_items_iface_get_type ())
#define PLANK_DBUS_ITEMS_IFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DBUS_ITEMS_IFACE, PlankDBusItemsIface))
#define PLANK_IS_DBUS_ITEMS_IFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DBUS_ITEMS_IFACE))
#define PLANK_DBUS_ITEMS_IFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLANK_TYPE_DBUS_ITEMS_IFACE, PlankDBusItemsIfaceIface))

typedef struct _PlankDBusItemsIface PlankDBusItemsIface;
typedef struct _PlankDBusItemsIfaceIface PlankDBusItemsIfaceIface;

#define PLANK_TYPE_DBUS_ITEMS_IFACE_PROXY (plank_dbus_items_iface_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PlankDBusClient {
	GObject parent_instance;
	PlankDBusClientPrivate * priv;
};

struct _PlankDBusClientClass {
	GObjectClass parent_class;
};

struct _PlankDBusItemsIfaceIface {
	GTypeInterface parent_iface;
	gboolean (*add) (PlankDBusItemsIface* self, const gchar* uri, GError** error);
	gboolean (*remove) (PlankDBusItemsIface* self, const gchar* uri, GError** error);
	gint (*get_count) (PlankDBusItemsIface* self, GError** error);
	gchar** (*get_persistent_applications) (PlankDBusItemsIface* self, int* result_length1, GError** error);
	gchar** (*get_transient_applications) (PlankDBusItemsIface* self, int* result_length1, GError** error);
};

struct _PlankDBusClientPrivate {
	GDBusConnection* connection;
	gchar* client_object_path;
	gchar* dock_bus_owner;
	gchar* dock_bus_name;
	gchar* dock_object_path;
	guint dbus_dock_ping_id;
	guint dbus_name_owner_changed_signal_id;
	PlankDBusItemsIface* items_proxy;
	gint items_count;
	gchar** persistent_apps_list;
	gint persistent_apps_list_length1;
	gint _persistent_apps_list_size_;
	gchar** transient_apps_list;
	gint transient_apps_list_length1;
	gint _transient_apps_list_size_;
};


static gpointer plank_dbus_client_parent_class = NULL;
static PlankDBusClient* plank_dbus_client_instance;
static PlankDBusClient* plank_dbus_client_instance = NULL;

GType plank_dbus_client_get_type (void) G_GNUC_CONST;
GType plank_dbus_items_iface_proxy_get_type (void) G_GNUC_CONST;
guint plank_dbus_items_iface_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType plank_dbus_items_iface_get_type (void) G_GNUC_CONST;
#define PLANK_DBUS_CLIENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_DBUS_CLIENT, PlankDBusClientPrivate))
enum  {
	PLANK_DBUS_CLIENT_DUMMY_PROPERTY,
	PLANK_DBUS_CLIENT_IS_CONNECTED
};
PlankDBusClient* plank_dbus_client_get_instance (void);
static PlankDBusClient* plank_dbus_client_new (void);
static PlankDBusClient* plank_dbus_client_construct (GType object_type);
static void plank_dbus_client_handle_dock_ping (GDBusConnection* connection, const gchar* sender_name, const gchar* object_path, const gchar* interface_name, const gchar* signal_name, GVariant* parameters, PlankDBusClient* self);
static void plank_dbus_client_connect_proxies (PlankDBusClient* self, GDBusConnection* connection, const gchar* sender_name, const gchar* object_path);
static void plank_dbus_client_handle_name_owner_changed (GDBusConnection* connection, const gchar* sender_name, const gchar* object_path, const gchar* interface_name, const gchar* signal_name, GVariant* parameters, PlankDBusClient* self);
static void plank_dbus_client_disconnect_proxies (PlankDBusClient* self);
static void plank_dbus_client_invalidate_items_cache (PlankDBusClient* self);
static void _plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed (PlankDBusItemsIface* _sender, gpointer self);
gboolean plank_dbus_client_add_item (PlankDBusClient* self, const gchar* uri);
gboolean plank_dbus_items_iface_add (PlankDBusItemsIface* self, const gchar* uri, GError** error);
gboolean plank_dbus_client_remove_item (PlankDBusClient* self, const gchar* uri);
gboolean plank_dbus_items_iface_remove (PlankDBusItemsIface* self, const gchar* uri, GError** error);
gint plank_dbus_client_get_items_count (PlankDBusClient* self);
gint plank_dbus_items_iface_get_count (PlankDBusItemsIface* self, GError** error);
gchar** plank_dbus_client_get_persistent_applications (PlankDBusClient* self, int* result_length1);
gchar** plank_dbus_items_iface_get_persistent_applications (PlankDBusItemsIface* self, int* result_length1, GError** error);
gchar** plank_dbus_client_get_transient_applications (PlankDBusClient* self, int* result_length1);
gchar** plank_dbus_items_iface_get_transient_applications (PlankDBusItemsIface* self, int* result_length1, GError** error);
gboolean plank_dbus_client_get_is_connected (PlankDBusClient* self);
static GObject * plank_dbus_client_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
#define PLANK_DBUS_DOCK_INTERFACE_NAME "net.launchpad.plank"
#define PLANK_DBUS_PING_NAME "Ping"
#define PLANK_DBUS_CLIENT_INTERFACE_NAME "net.launchpad.plank.Client"
static void plank_dbus_client_finalize (GObject* obj);
static void _vala_plank_dbus_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * Get the singleton instance of {@link Plank.DBusClient}
 */
PlankDBusClient* plank_dbus_client_get_instance (void) {
	PlankDBusClient* result = NULL;
	PlankDBusClient* _tmp0_ = NULL;
	PlankDBusClient* _tmp2_ = NULL;
	_tmp0_ = plank_dbus_client_instance;
	if (_tmp0_ == NULL) {
		PlankDBusClient* _tmp1_ = NULL;
		_tmp1_ = plank_dbus_client_new ();
		_g_object_unref0 (plank_dbus_client_instance);
		plank_dbus_client_instance = _tmp1_;
	}
	_tmp2_ = plank_dbus_client_instance;
	result = _tmp2_;
	return result;
}


static PlankDBusClient* plank_dbus_client_construct (GType object_type) {
	PlankDBusClient * self = NULL;
	self = (PlankDBusClient*) g_object_new (object_type, NULL);
	return self;
}


static PlankDBusClient* plank_dbus_client_new (void) {
	return plank_dbus_client_construct (PLANK_TYPE_DBUS_CLIENT);
}


static void plank_dbus_client_handle_dock_ping (GDBusConnection* connection, const gchar* sender_name, const gchar* object_path, const gchar* interface_name, const gchar* signal_name, GVariant* parameters, PlankDBusClient* self) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (sender_name != NULL);
	g_return_if_fail (object_path != NULL);
	g_return_if_fail (interface_name != NULL);
	g_return_if_fail (signal_name != NULL);
	g_return_if_fail (parameters != NULL);
	_tmp1_ = self->priv->dock_bus_name;
	if (_tmp1_ == NULL) {
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		_tmp2_ = self->priv->dock_bus_name;
		_tmp3_ = sender_name;
		_tmp0_ = g_strcmp0 (_tmp2_, _tmp3_) != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GDBusConnection* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		_tmp4_ = connection;
		_tmp5_ = sender_name;
		_tmp6_ = object_path;
		plank_dbus_client_connect_proxies (self, _tmp4_, _tmp5_, _tmp6_);
	}
}


static void plank_dbus_client_handle_name_owner_changed (GDBusConnection* connection, const gchar* sender_name, const gchar* object_path, const gchar* interface_name, const gchar* signal_name, GVariant* parameters, PlankDBusClient* self) {
	gchar* name = NULL;
	gchar* before = NULL;
	gchar* after = NULL;
	GVariant* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_ = NULL;
	GDBusConnection* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (sender_name != NULL);
	g_return_if_fail (object_path != NULL);
	g_return_if_fail (interface_name != NULL);
	g_return_if_fail (signal_name != NULL);
	g_return_if_fail (parameters != NULL);
	_tmp0_ = parameters;
	g_variant_get (_tmp0_, "(sss)", &name, &before, &after, NULL);
	_tmp2_ = self->priv->dock_bus_owner;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		_tmp3_ = self->priv->dock_bus_owner;
		_tmp4_ = after;
		_tmp1_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_g_free0 (after);
		_g_free0 (before);
		_g_free0 (name);
		return;
	}
	_tmp7_ = name;
	if (_tmp7_ != NULL) {
		const gchar* _tmp8_ = NULL;
		_tmp8_ = name;
		_tmp6_ = g_strcmp0 (_tmp8_, "") != 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		_tmp9_ = name;
		_tmp10_ = self->priv->dock_bus_name;
		_tmp5_ = g_strcmp0 (_tmp9_, _tmp10_) != 0;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_g_free0 (after);
		_g_free0 (before);
		_g_free0 (name);
		return;
	}
	_tmp12_ = after;
	if (_tmp12_ == NULL) {
		_tmp11_ = TRUE;
	} else {
		const gchar* _tmp13_ = NULL;
		_tmp13_ = after;
		_tmp11_ = g_strcmp0 (_tmp13_, "") == 0;
	}
	if (_tmp11_) {
		plank_dbus_client_disconnect_proxies (self);
		_g_free0 (after);
		_g_free0 (before);
		_g_free0 (name);
		return;
	}
	_tmp14_ = connection;
	_tmp15_ = name;
	_tmp16_ = object_path;
	plank_dbus_client_connect_proxies (self, _tmp14_, _tmp15_, _tmp16_);
	_g_free0 (after);
	_g_free0 (before);
	_g_free0 (name);
}


static void _plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed (PlankDBusItemsIface* _sender, gpointer self) {
	plank_dbus_client_invalidate_items_cache ((PlankDBusClient*) self);
}


static void plank_dbus_client_connect_proxies (PlankDBusClient* self, GDBusConnection* connection, const gchar* sender_name, const gchar* object_path) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (sender_name != NULL);
	g_return_if_fail (object_path != NULL);
	_tmp0_ = sender_name;
	_tmp1_ = object_path;
	g_debug ("Client.vala:154: Connecting and create proxies for '%s' (%s)", _tmp0_, _tmp1_);
	{
		PlankDBusItemsIface* _tmp2_ = NULL;
		GDBusConnection* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		PlankDBusItemsIface* _tmp6_ = NULL;
		PlankDBusItemsIface* _tmp7_ = NULL;
		PlankDBusItemsIface* _tmp8_ = NULL;
		PlankDBusItemsIface* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp3_ = connection;
		_tmp4_ = sender_name;
		_tmp5_ = object_path;
		_tmp6_ = g_initable_new (PLANK_TYPE_DBUS_ITEMS_IFACE_PROXY, NULL, &_inner_error_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", _tmp4_, "g-connection", _tmp3_, "g-object-path", _tmp5_, "g-interface-name", "net.launchpad.plank.Items", "g-interface-info", g_type_get_qdata (PLANK_TYPE_DBUS_ITEMS_IFACE, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
		_tmp2_ = (PlankDBusItemsIface*) _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch5_g_error;
		}
		_tmp7_ = _tmp2_;
		_tmp2_ = NULL;
		_g_object_unref0 (self->priv->items_proxy);
		self->priv->items_proxy = _tmp7_;
		_tmp8_ = self->priv->items_proxy;
		g_signal_connect_object (_tmp8_, "changed", (GCallback) _plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed, self, 0);
		_tmp9_ = self->priv->items_proxy;
		_tmp10_ = g_dbus_proxy_get_name_owner (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, G_TYPE_DBUS_PROXY, GDBusProxy));
		_g_free0 (self->priv->dock_bus_owner);
		self->priv->dock_bus_owner = _tmp10_;
		_tmp11_ = sender_name;
		_tmp12_ = g_strdup (_tmp11_);
		_g_free0 (self->priv->dock_bus_name);
		self->priv->dock_bus_name = _tmp12_;
		_tmp13_ = object_path;
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (self->priv->dock_object_path);
		self->priv->dock_object_path = _tmp14_;
		_g_object_unref0 (_tmp2_);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_free0 (self->priv->dock_bus_owner);
		self->priv->dock_bus_owner = NULL;
		_g_free0 (self->priv->dock_bus_name);
		self->priv->dock_bus_name = NULL;
		_g_free0 (self->priv->dock_object_path);
		self->priv->dock_object_path = NULL;
		_g_object_unref0 (self->priv->items_proxy);
		self->priv->items_proxy = NULL;
		_tmp15_ = sender_name;
		_tmp16_ = object_path;
		g_critical ("Client.vala:168: Failed to create items proxy for '%s' (%s)", _tmp15_, _tmp16_);
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_signal_emit_by_name (self, "proxy-changed");
}


static void plank_dbus_client_disconnect_proxies (PlankDBusClient* self) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	PlankDBusItemsIface* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->dock_bus_name;
	_tmp1_ = self->priv->dock_object_path;
	g_debug ("Client.vala:176: Disconnecting from '%s' (%s)", _tmp0_, _tmp1_);
	_g_free0 (self->priv->dock_bus_owner);
	self->priv->dock_bus_owner = NULL;
	_g_free0 (self->priv->dock_bus_name);
	self->priv->dock_bus_name = NULL;
	_g_free0 (self->priv->dock_object_path);
	self->priv->dock_object_path = NULL;
	_tmp2_ = self->priv->items_proxy;
	g_signal_parse_name ("changed", PLANK_TYPE_DBUS_ITEMS_IFACE, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed, self);
	_g_object_unref0 (self->priv->items_proxy);
	self->priv->items_proxy = NULL;
}


static void plank_dbus_client_invalidate_items_cache (PlankDBusClient* self) {
	g_return_if_fail (self != NULL);
	self->priv->items_count = G_MININT;
	self->priv->persistent_apps_list = (_vala_array_free (self->priv->persistent_apps_list, self->priv->persistent_apps_list_length1, (GDestroyNotify) g_free), NULL);
	self->priv->persistent_apps_list = NULL;
	self->priv->persistent_apps_list_length1 = 0;
	self->priv->_persistent_apps_list_size_ = self->priv->persistent_apps_list_length1;
	self->priv->transient_apps_list = (_vala_array_free (self->priv->transient_apps_list, self->priv->transient_apps_list_length1, (GDestroyNotify) g_free), NULL);
	self->priv->transient_apps_list = NULL;
	self->priv->transient_apps_list_length1 = 0;
	self->priv->_transient_apps_list_size_ = self->priv->transient_apps_list_length1;
}


/**
 * Add a new item for the given uri to the dock
 *
 * @param uri an URI
 * @return whether it was successfully added
 */
gboolean plank_dbus_client_add_item (PlankDBusClient* self, const gchar* uri) {
	gboolean result = FALSE;
	PlankDBusItemsIface* _tmp0_ = NULL;
	gboolean _tmp8_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (uri != NULL, FALSE);
	_tmp0_ = self->priv->items_proxy;
	if (_tmp0_ == NULL) {
		g_warning ("Client.vala:203: No proxy connected");
		result = FALSE;
		return result;
	}
	{
		gboolean _tmp1_ = FALSE;
		PlankDBusItemsIface* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		_tmp2_ = self->priv->items_proxy;
		_tmp3_ = uri;
		_tmp4_ = plank_dbus_items_iface_add (_tmp2_, _tmp3_, &_inner_error_);
		_tmp1_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp5_ = FALSE;
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch6_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp5_;
		}
		result = _tmp1_;
		return result;
	}
	goto __finally6;
	__catch6_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Client.vala:210: %s", _tmp7_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally6:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return _tmp8_;
}


/**
 * Remove an existing item for the given uri from the dock
 *
 * @param uri an URI
 * @return whether it was successfully removed
 */
gboolean plank_dbus_client_remove_item (PlankDBusClient* self, const gchar* uri) {
	gboolean result = FALSE;
	PlankDBusItemsIface* _tmp0_ = NULL;
	gboolean _tmp8_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (uri != NULL, FALSE);
	_tmp0_ = self->priv->items_proxy;
	if (_tmp0_ == NULL) {
		g_warning ("Client.vala:224: No proxy connected");
		result = FALSE;
		return result;
	}
	{
		gboolean _tmp1_ = FALSE;
		PlankDBusItemsIface* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		_tmp2_ = self->priv->items_proxy;
		_tmp3_ = uri;
		_tmp4_ = plank_dbus_items_iface_remove (_tmp2_, _tmp3_, &_inner_error_);
		_tmp1_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp5_ = FALSE;
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch7_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp5_;
		}
		result = _tmp1_;
		return result;
	}
	goto __finally7;
	__catch7_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Client.vala:231: %s", _tmp7_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally7:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return _tmp8_;
}


/**
 * Returns the number of currently visible items on the dock
 *
 * @return the item-count
 */
gint plank_dbus_client_get_items_count (PlankDBusClient* self) {
	gint result = 0;
	PlankDBusItemsIface* _tmp0_ = NULL;
	gint _tmp9_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->items_proxy;
	if (_tmp0_ == NULL) {
		g_warning ("Client.vala:244: No proxy connected");
		result = -1;
		return result;
	}
	{
		gint _tmp1_ = 0;
		_tmp1_ = self->priv->items_count;
		if (_tmp1_ == G_MININT) {
			gint _tmp2_ = 0;
			PlankDBusItemsIface* _tmp3_ = NULL;
			gint _tmp4_ = 0;
			_tmp3_ = self->priv->items_proxy;
			_tmp4_ = plank_dbus_items_iface_get_count (_tmp3_, &_inner_error_);
			_tmp2_ = _tmp4_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				gint _tmp5_ = 0;
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch8_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return _tmp5_;
			}
			self->priv->items_count = _tmp2_;
		}
	}
	goto __finally8;
	__catch8_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Client.vala:252: %s", _tmp7_);
		result = -1;
		_g_error_free0 (e);
		return result;
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp8_ = 0;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp8_;
	}
	_tmp9_ = self->priv->items_count;
	result = _tmp9_;
	return result;
}


/**
 * Returns an array of uris of the persistent applications on the dock
 *
 * @return the array of uris
 */
gchar** plank_dbus_client_get_persistent_applications (PlankDBusClient* self, int* result_length1) {
	gchar** result = NULL;
	PlankDBusItemsIface* _tmp0_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->items_proxy;
	if (_tmp0_ == NULL) {
		gchar** _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		g_warning ("Client.vala:267: No proxy connected");
		_tmp1_ = NULL;
		_tmp1__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp1__length1;
		}
		result = _tmp1_;
		return result;
	}
	_tmp2_ = self->priv->persistent_apps_list;
	_tmp2__length1 = self->priv->persistent_apps_list_length1;
	if (_tmp2_ != NULL) {
		gchar** _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp3_ = self->priv->persistent_apps_list;
		_tmp3__length1 = self->priv->persistent_apps_list_length1;
		_tmp4_ = _tmp3_;
		_tmp4__length1 = _tmp3__length1;
		if (result_length1) {
			*result_length1 = _tmp4__length1;
		}
		result = _tmp4_;
		return result;
	}
	{
		gchar** _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gchar** _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		gchar** _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		_tmp5_ = self->priv->persistent_apps_list;
		_tmp5__length1 = self->priv->persistent_apps_list_length1;
		if (_tmp5_ == NULL) {
			gchar** _tmp6_ = NULL;
			PlankDBusItemsIface* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			gchar** _tmp9_ = NULL;
			gint _tmp6__length1 = 0;
			gint __tmp6__size_ = 0;
			gchar** _tmp10_ = NULL;
			gint _tmp10__length1 = 0;
			_tmp7_ = self->priv->items_proxy;
			_tmp9_ = plank_dbus_items_iface_get_persistent_applications (_tmp7_, &_tmp8_, &_inner_error_);
			_tmp6_ = _tmp9_;
			_tmp6__length1 = _tmp8_;
			__tmp6__size_ = _tmp6__length1;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch9_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_tmp10_ = _tmp6_;
			_tmp10__length1 = _tmp6__length1;
			_tmp6_ = NULL;
			_tmp6__length1 = 0;
			self->priv->persistent_apps_list = (_vala_array_free (self->priv->persistent_apps_list, self->priv->persistent_apps_list_length1, (GDestroyNotify) g_free), NULL);
			self->priv->persistent_apps_list = _tmp10_;
			self->priv->persistent_apps_list_length1 = _tmp10__length1;
			self->priv->_persistent_apps_list_size_ = self->priv->persistent_apps_list_length1;
			_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp11_ = self->priv->persistent_apps_list;
		_tmp11__length1 = self->priv->persistent_apps_list_length1;
		_tmp12_ = _tmp11_;
		_tmp12__length1 = _tmp11__length1;
		if (result_length1) {
			*result_length1 = _tmp12__length1;
		}
		result = _tmp12_;
		return result;
	}
	goto __finally9;
	__catch9_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_warning ("Client.vala:279: %s", _tmp14_);
		_g_error_free0 (e);
	}
	__finally9:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp15_ = NULL;
	_tmp15__length1 = 0;
	if (result_length1) {
		*result_length1 = _tmp15__length1;
	}
	result = _tmp15_;
	return result;
}


/**
 * Returns an array of uris of the transient applications on the dock
 *
 * @return the array of uris
 */
gchar** plank_dbus_client_get_transient_applications (PlankDBusClient* self, int* result_length1) {
	gchar** result = NULL;
	PlankDBusItemsIface* _tmp0_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->items_proxy;
	if (_tmp0_ == NULL) {
		gchar** _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		g_warning ("Client.vala:293: No proxy connected");
		_tmp1_ = NULL;
		_tmp1__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp1__length1;
		}
		result = _tmp1_;
		return result;
	}
	_tmp2_ = self->priv->transient_apps_list;
	_tmp2__length1 = self->priv->transient_apps_list_length1;
	if (_tmp2_ != NULL) {
		gchar** _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp3_ = self->priv->transient_apps_list;
		_tmp3__length1 = self->priv->transient_apps_list_length1;
		_tmp4_ = _tmp3_;
		_tmp4__length1 = _tmp3__length1;
		if (result_length1) {
			*result_length1 = _tmp4__length1;
		}
		result = _tmp4_;
		return result;
	}
	{
		gchar** _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gchar** _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		gchar** _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		_tmp5_ = self->priv->transient_apps_list;
		_tmp5__length1 = self->priv->transient_apps_list_length1;
		if (_tmp5_ == NULL) {
			gchar** _tmp6_ = NULL;
			PlankDBusItemsIface* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			gchar** _tmp9_ = NULL;
			gint _tmp6__length1 = 0;
			gint __tmp6__size_ = 0;
			gchar** _tmp10_ = NULL;
			gint _tmp10__length1 = 0;
			_tmp7_ = self->priv->items_proxy;
			_tmp9_ = plank_dbus_items_iface_get_transient_applications (_tmp7_, &_tmp8_, &_inner_error_);
			_tmp6_ = _tmp9_;
			_tmp6__length1 = _tmp8_;
			__tmp6__size_ = _tmp6__length1;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch10_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_tmp10_ = _tmp6_;
			_tmp10__length1 = _tmp6__length1;
			_tmp6_ = NULL;
			_tmp6__length1 = 0;
			self->priv->transient_apps_list = (_vala_array_free (self->priv->transient_apps_list, self->priv->transient_apps_list_length1, (GDestroyNotify) g_free), NULL);
			self->priv->transient_apps_list = _tmp10_;
			self->priv->transient_apps_list_length1 = _tmp10__length1;
			self->priv->_transient_apps_list_size_ = self->priv->transient_apps_list_length1;
			_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp11_ = self->priv->transient_apps_list;
		_tmp11__length1 = self->priv->transient_apps_list_length1;
		_tmp12_ = _tmp11_;
		_tmp12__length1 = _tmp11__length1;
		if (result_length1) {
			*result_length1 = _tmp12__length1;
		}
		result = _tmp12_;
		return result;
	}
	goto __finally10;
	__catch10_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_warning ("Client.vala:305: %s", _tmp14_);
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp15_ = NULL;
	_tmp15__length1 = 0;
	if (result_length1) {
		*result_length1 = _tmp15__length1;
	}
	result = _tmp15_;
	return result;
}


gboolean plank_dbus_client_get_is_connected (PlankDBusClient* self) {
	gboolean result;
	PlankDBusItemsIface* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->items_proxy;
	result = _tmp0_ != NULL;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GObject * plank_dbus_client_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankDBusClient * self;
	GApplication* application = NULL;
	GApplication* _tmp0_ = NULL;
	gchar* object_path = NULL;
	GApplication* _tmp1_ = NULL;
	gboolean _tmp8_ = FALSE;
	GDBusConnection* _tmp9_ = NULL;
	GDBusConnection* _tmp15_ = NULL;
	guint _tmp16_ = 0U;
	gchar* _tmp17_ = NULL;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (plank_dbus_client_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DBUS_CLIENT, PlankDBusClient);
	_tmp0_ = g_application_get_default ();
	application = _tmp0_;
	object_path = NULL;
	_tmp1_ = application;
	if (_tmp1_ != NULL) {
		GApplication* _tmp2_ = NULL;
		GDBusConnection* _tmp3_ = NULL;
		GDBusConnection* _tmp4_ = NULL;
		GApplication* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		_tmp2_ = application;
		_tmp3_ = g_application_get_dbus_connection (_tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_g_object_unref0 (self->priv->connection);
		self->priv->connection = _tmp4_;
		_tmp5_ = application;
		_tmp6_ = g_application_get_dbus_object_path (_tmp5_);
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (object_path);
		object_path = _tmp7_;
	}
	_tmp9_ = self->priv->connection;
	if (_tmp9_ == NULL) {
		_tmp8_ = TRUE;
	} else {
		const gchar* _tmp10_ = NULL;
		_tmp10_ = object_path;
		_tmp8_ = _tmp10_ == NULL;
	}
	if (_tmp8_) {
		g_critical ("Client.vala:88: Initializing client failed");
		_g_free0 (object_path);
		return obj;
	}
	{
		GDBusConnection* _tmp11_ = NULL;
		guint _tmp12_ = 0U;
		_tmp11_ = self->priv->connection;
		_tmp12_ = g_dbus_connection_signal_subscribe (_tmp11_, NULL, PLANK_DBUS_DOCK_INTERFACE_NAME, PLANK_DBUS_PING_NAME, NULL, NULL, G_DBUS_SIGNAL_FLAGS_NONE, (GDBusSignalCallback) plank_dbus_client_handle_dock_ping, g_object_ref (self), NULL);
		self->priv->dbus_dock_ping_id = _tmp12_;
	}
	goto __finally11;
	__catch11_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_warning ("Client.vala:97: Could not subscribe for dock signal (%s)", _tmp14_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (object_path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp15_ = self->priv->connection;
	_tmp16_ = g_dbus_connection_signal_subscribe (_tmp15_, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameOwnerChanged", "/org/freedesktop/DBus", NULL, G_DBUS_SIGNAL_FLAGS_NONE, (GDBusSignalCallback) plank_dbus_client_handle_name_owner_changed, g_object_ref (self), NULL);
	self->priv->dbus_name_owner_changed_signal_id = _tmp16_;
	_tmp17_ = object_path;
	object_path = NULL;
	_g_free0 (self->priv->client_object_path);
	self->priv->client_object_path = _tmp17_;
	{
		GDBusConnection* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		_tmp18_ = self->priv->connection;
		_tmp19_ = self->priv->client_object_path;
		g_dbus_connection_emit_signal (_tmp18_, NULL, _tmp19_, PLANK_DBUS_CLIENT_INTERFACE_NAME, PLANK_DBUS_PING_NAME, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch12_g_error;
		}
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		g_warning ("Client.vala:109: Could not ping running docks (%s)", _tmp21_);
		_g_error_free0 (e);
	}
	__finally12:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (object_path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_g_free0 (object_path);
	return obj;
}


static void plank_dbus_client_class_init (PlankDBusClientClass * klass) {
	plank_dbus_client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankDBusClientPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dbus_client_get_property;
	G_OBJECT_CLASS (klass)->constructor = plank_dbus_client_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_dbus_client_finalize;
	/**
	 * Whether the client is in an operatable state and connected to
	 * a running dock
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DBUS_CLIENT_IS_CONNECTED, g_param_spec_boolean ("is-connected", "is-connected", "is-connected", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * If the proxy interfaces for the dock are ready to be used
	 * or were changed on runtime this signal will be emitted.
	 */
	g_signal_new ("proxy_changed", PLANK_TYPE_DBUS_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void plank_dbus_client_instance_init (PlankDBusClient * self) {
	self->priv = PLANK_DBUS_CLIENT_GET_PRIVATE (self);
	self->priv->connection = NULL;
	self->priv->dbus_dock_ping_id = (guint) 0;
	self->priv->dbus_name_owner_changed_signal_id = (guint) 0;
	self->priv->items_proxy = NULL;
	self->priv->items_count = G_MININT;
	self->priv->persistent_apps_list = NULL;
	self->priv->persistent_apps_list_length1 = 0;
	self->priv->_persistent_apps_list_size_ = self->priv->persistent_apps_list_length1;
	self->priv->transient_apps_list = NULL;
	self->priv->transient_apps_list_length1 = 0;
	self->priv->_transient_apps_list_size_ = self->priv->transient_apps_list_length1;
}


static void plank_dbus_client_finalize (GObject* obj) {
	PlankDBusClient * self;
	GDBusConnection* _tmp0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DBUS_CLIENT, PlankDBusClient);
	_tmp0_ = self->priv->connection;
	if (_tmp0_ != NULL) {
		guint _tmp1_ = 0U;
		guint _tmp4_ = 0U;
		_tmp1_ = self->priv->dbus_dock_ping_id;
		if (_tmp1_ > ((guint) 0)) {
			GDBusConnection* _tmp2_ = NULL;
			guint _tmp3_ = 0U;
			_tmp2_ = self->priv->connection;
			_tmp3_ = self->priv->dbus_dock_ping_id;
			g_dbus_connection_signal_unsubscribe (_tmp2_, _tmp3_);
		}
		_tmp4_ = self->priv->dbus_name_owner_changed_signal_id;
		if (_tmp4_ > ((guint) 0)) {
			GDBusConnection* _tmp5_ = NULL;
			guint _tmp6_ = 0U;
			_tmp5_ = self->priv->connection;
			_tmp6_ = self->priv->dbus_name_owner_changed_signal_id;
			g_dbus_connection_signal_unsubscribe (_tmp5_, _tmp6_);
		}
	}
	_g_object_unref0 (self->priv->connection);
	_g_free0 (self->priv->client_object_path);
	_g_free0 (self->priv->dock_bus_owner);
	_g_free0 (self->priv->dock_bus_name);
	_g_free0 (self->priv->dock_object_path);
	_g_object_unref0 (self->priv->items_proxy);
	self->priv->persistent_apps_list = (_vala_array_free (self->priv->persistent_apps_list, self->priv->persistent_apps_list_length1, (GDestroyNotify) g_free), NULL);
	self->priv->transient_apps_list = (_vala_array_free (self->priv->transient_apps_list, self->priv->transient_apps_list_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (plank_dbus_client_parent_class)->finalize (obj);
}


/**
 * Connects to a running instance of plank via DBus and
 * provides remote interface to a currently runnning dock.
 */
GType plank_dbus_client_get_type (void) {
	static volatile gsize plank_dbus_client_type_id__volatile = 0;
	if (g_once_init_enter (&plank_dbus_client_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDBusClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dbus_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDBusClient), 0, (GInstanceInitFunc) plank_dbus_client_instance_init, NULL };
		GType plank_dbus_client_type_id;
		plank_dbus_client_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDBusClient", &g_define_type_info, 0);
		g_once_init_leave (&plank_dbus_client_type_id__volatile, plank_dbus_client_type_id);
	}
	return plank_dbus_client_type_id__volatile;
}


static void _vala_plank_dbus_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankDBusClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DBUS_CLIENT, PlankDBusClient);
	switch (property_id) {
		case PLANK_DBUS_CLIENT_IS_CONNECTED:
		g_value_set_boolean (value, plank_dbus_client_get_is_connected (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



