/* Preferences.c generated by valac 0.34.7, the Vala compiler
 * generated from Preferences.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define PLANK_TYPE_SERIALIZABLE (plank_serializable_get_type ())
#define PLANK_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_SERIALIZABLE, PlankSerializable))
#define PLANK_IS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_SERIALIZABLE))
#define PLANK_SERIALIZABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLANK_TYPE_SERIALIZABLE, PlankSerializableIface))

typedef struct _PlankSerializable PlankSerializable;
typedef struct _PlankSerializableIface PlankSerializableIface;

#define PLANK_TYPE_PREFERENCES (plank_preferences_get_type ())
#define PLANK_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_PREFERENCES, PlankPreferences))
#define PLANK_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_PREFERENCES, PlankPreferencesClass))
#define PLANK_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_PREFERENCES))
#define PLANK_IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_PREFERENCES))
#define PLANK_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_PREFERENCES, PlankPreferencesClass))

typedef struct _PlankPreferences PlankPreferences;
typedef struct _PlankPreferencesClass PlankPreferencesClass;
typedef struct _PlankPreferencesPrivate PlankPreferencesPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))

#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankSerializableIface {
	GTypeInterface parent_iface;
	gchar* (*serialize) (PlankSerializable* self);
	void (*deserialize) (PlankSerializable* self, const gchar* s);
};

struct _PlankPreferences {
	GObject parent_instance;
	PlankPreferencesPrivate * priv;
};

struct _PlankPreferencesClass {
	GObjectClass parent_class;
	void (*verify) (PlankPreferences* self, const gchar* prop);
	void (*reset_properties) (PlankPreferences* self);
};

struct _PlankPreferencesPrivate {
	GFile* backing_file;
	GFileMonitor* backing_monitor;
	gboolean read_only;
	gboolean is_delayed;
	gboolean is_delayed_internal;
	gboolean is_changed;
};


static gpointer plank_preferences_parent_class = NULL;
static gchar** plank_preferences_TRANSITION_MAP;
static gint plank_preferences_TRANSITION_MAP_length1;
static gint plank_preferences_TRANSITION_MAP_length2;
static gchar** plank_preferences_TRANSITION_MAP = NULL;
static gint plank_preferences_TRANSITION_MAP_length1 = 0;
static gint plank_preferences_TRANSITION_MAP_length2 = 0;

GType plank_serializable_get_type (void) G_GNUC_CONST;
gchar* plank_serializable_serialize (PlankSerializable* self);
void plank_serializable_deserialize (PlankSerializable* self, const gchar* s);
GType plank_preferences_get_type (void) G_GNUC_CONST;
#define PLANK_PREFERENCES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_PREFERENCES, PlankPreferencesPrivate))
enum  {
	PLANK_PREFERENCES_DUMMY_PROPERTY
};
static void plank_preferences_handle_notify (PlankPreferences* self, GObject* sender, GParamSpec* property);
static void _plank_preferences_handle_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
void plank_preferences_apply (PlankPreferences* self);
static void plank_preferences_stop_monitor (PlankPreferences* self);
PlankPreferences* plank_preferences_construct (GType object_type);
void plank_logger_verbose (const gchar* msg, ...);
static void plank_preferences_save_prefs (PlankPreferences* self);
static void plank_preferences_call_verify (PlankPreferences* self, const gchar* prop);
static void plank_preferences_handle_verify_notify (PlankPreferences* self, GObject* sender, GParamSpec* property);
static void _plank_preferences_handle_verify_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
void plank_preferences_verify (PlankPreferences* self, const gchar* prop);
static void plank_preferences_real_verify (PlankPreferences* self, const gchar* prop);
void plank_preferences_reset_properties (PlankPreferences* self);
static void plank_preferences_real_reset_properties (PlankPreferences* self);
PlankPreferences* plank_preferences_construct_with_file (GType object_type, GFile* file);
void plank_preferences_init_from_file (PlankPreferences* self, GFile* file);
PlankPreferences* plank_preferences_construct_with_filename (GType object_type, const gchar* filename);
GFile* plank_paths_get_AppConfigFolder (void);
static void plank_preferences_load_prefs (PlankPreferences* self);
static void plank_preferences_start_monitor (PlankPreferences* self);
void plank_preferences_init_from_filename (PlankPreferences* self, const gchar* filename);
void plank_preferences_delay (PlankPreferences* self);
gchar* plank_preferences_get_filename (PlankPreferences* self);
GFile* plank_preferences_get_backing_file (PlankPreferences* self);
void plank_preferences_delete (PlankPreferences* self);
static void plank_preferences_backing_file_changed (GFile* f, GFile* other, GFileMonitorEvent event, PlankPreferences* self);
static void _plank_preferences_backing_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
gchar* plank_color_to_prefs_string (PlankColor *self);
void plank_color_from_prefs_string (const gchar* s, PlankColor* result);
static GObject * plank_preferences_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void plank_preferences_finalize (GObject* obj);


/**
 * Serializes the object into a string representation.
 *
 * @return the string representation of the object
 */
gchar* plank_serializable_serialize (PlankSerializable* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return PLANK_SERIALIZABLE_GET_INTERFACE (self)->serialize (self);
}


/**
 * De-serializes the object from a string representation.
 *
 * @param s the string representation of the object
 */
void plank_serializable_deserialize (PlankSerializable* self, const gchar* s) {
	g_return_if_fail (self != NULL);
	PLANK_SERIALIZABLE_GET_INTERFACE (self)->deserialize (self, s);
}


static void plank_serializable_base_init (PlankSerializableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * This interface is used by objects that need to be serialized in a Preferences.
 * The object must have a string representation and provide these methods to
 * translate between the string and object representations.
 */
GType plank_serializable_get_type (void) {
	static volatile gsize plank_serializable_type_id__volatile = 0;
	if (g_once_init_enter (&plank_serializable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankSerializableIface), (GBaseInitFunc) plank_serializable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType plank_serializable_type_id;
		plank_serializable_type_id = g_type_register_static (G_TYPE_INTERFACE, "PlankSerializable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (plank_serializable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&plank_serializable_type_id__volatile, plank_serializable_type_id);
	}
	return plank_serializable_type_id__volatile;
}


static void _plank_preferences_handle_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	plank_preferences_handle_notify ((PlankPreferences*) self, _sender, pspec);
}


/**
 * Creates a new preferences object with no backing file.
 */
PlankPreferences* plank_preferences_construct (GType object_type) {
	PlankPreferences * self = NULL;
	self = (PlankPreferences*) g_object_new (object_type, NULL);
	return self;
}


static void plank_preferences_handle_notify (PlankPreferences* self, GObject* sender, GParamSpec* property) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_ = 0U;
	GParamSpec* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GParamSpec* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _plank_preferences_handle_notify_g_object_notify, self);
	g_object_freeze_notify ((GObject*) self);
	_tmp2_ = property;
	_tmp3_ = _tmp2_->name;
	plank_logger_verbose ("property changed: %s", _tmp3_, NULL);
	self->priv->is_delayed_internal = TRUE;
	_tmp4_ = self->priv->backing_file;
	if (_tmp4_ != NULL) {
		plank_preferences_save_prefs (self);
	}
	_tmp5_ = property;
	_tmp6_ = _tmp5_->name;
	plank_preferences_call_verify (self, _tmp6_);
	self->priv->is_delayed_internal = FALSE;
	_tmp9_ = self->priv->is_delayed;
	if (!_tmp9_) {
		gboolean _tmp10_ = FALSE;
		_tmp10_ = self->priv->is_changed;
		_tmp8_ = _tmp10_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		GFile* _tmp11_ = NULL;
		_tmp11_ = self->priv->backing_file;
		_tmp7_ = _tmp11_ != NULL;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		plank_preferences_save_prefs (self);
	}
	g_object_thaw_notify ((GObject*) self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_notify_g_object_notify, self, 0);
}


static void plank_preferences_handle_verify_notify (PlankPreferences* self, GObject* sender, GParamSpec* property) {
	GFile* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	plank_preferences_save_prefs (self);
	_tmp0_ = self->priv->backing_file;
	if (_tmp0_ != NULL) {
		gchar* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GParamSpec* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		_tmp2_ = self->priv->backing_file;
		_tmp3_ = g_file_get_path (_tmp2_);
		_tmp1_ = _tmp3_;
		if (_tmp1_ == NULL) {
			gchar* _tmp4_ = NULL;
			_tmp4_ = g_strdup ("");
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp4_;
		}
		_tmp5_ = property;
		_tmp6_ = _tmp5_->name;
		g_warning ("Preferences.vala:113: Key '%s' failed verification in preferences file" \
" '%s', changing value", _tmp6_, _tmp1_);
		_g_free0 (_tmp1_);
	} else {
		GParamSpec* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		_tmp7_ = property;
		_tmp8_ = _tmp7_->name;
		g_warning ("Preferences.vala:115: Key '%s' failed verification, changing value", _tmp8_);
	}
}


static void _plank_preferences_handle_verify_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	plank_preferences_handle_verify_notify ((PlankPreferences*) self, _sender, pspec);
}


static void plank_preferences_call_verify (PlankPreferences* self, const gchar* prop) {
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prop != NULL);
	g_object_freeze_notify ((GObject*) self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_verify_notify_g_object_notify, self, 0);
	_tmp0_ = prop;
	plank_preferences_verify (self, _tmp0_);
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _plank_preferences_handle_verify_notify_g_object_notify, self);
	g_object_thaw_notify ((GObject*) self);
}


/**
 * This method will verify the value of a property.
 * If the value is wrong, this method should replace it with a sanitized value.
 *
 * @param prop the name of the property that needs verified
 */
static void plank_preferences_real_verify (PlankPreferences* self, const gchar* prop) {
	g_return_if_fail (prop != NULL);
}


void plank_preferences_verify (PlankPreferences* self, const gchar* prop) {
	g_return_if_fail (self != NULL);
	PLANK_PREFERENCES_GET_CLASS (self)->verify (self, prop);
}


/**
 * Resets all properties to their default values.  Called from construct and before
 * loading from the backing file.
 */
static void plank_preferences_real_reset_properties (PlankPreferences* self) {
	g_critical ("Type `%s' does not implement abstract method `plank_preferences_reset_properties'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void plank_preferences_reset_properties (PlankPreferences* self) {
	g_return_if_fail (self != NULL);
	PLANK_PREFERENCES_GET_CLASS (self)->reset_properties (self);
}


/**
 * Creates a preferences object with a backing file.
 *
 * @param file the {@link GLib.File} of the backing file for this preferences
 */
PlankPreferences* plank_preferences_construct_with_file (GType object_type, GFile* file) {
	PlankPreferences * self = NULL;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	self = (PlankPreferences*) g_object_new (object_type, NULL);
	_tmp0_ = file;
	plank_preferences_init_from_file (self, _tmp0_);
	return self;
}


/**
 * Creates a preferences object with a backing filename.
 *
 * @param filename of the backing file for this preferences
 */
PlankPreferences* plank_preferences_construct_with_filename (GType object_type, const gchar* filename) {
	PlankPreferences * self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	self = (PlankPreferences*) g_object_new (object_type, NULL);
	_tmp0_ = plank_paths_get_AppConfigFolder ();
	_tmp1_ = _tmp0_;
	_tmp2_ = filename;
	_tmp3_ = g_file_get_child (_tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	plank_preferences_init_from_file (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
	return self;
}


/**
 * Initializes this preferences with a backing file.
 *
 * @param file the {@link GLib.File} of the backing file for this preferences
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void plank_preferences_init_from_file (PlankPreferences* self, GFile* file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gboolean file_exists = FALSE;
	GFile* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp28_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	plank_preferences_stop_monitor (self);
	_tmp0_ = file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->backing_file);
	self->priv->backing_file = _tmp1_;
	_tmp2_ = self->priv->backing_file;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	file_exists = _tmp3_;
	_tmp4_ = self->priv->read_only;
	if (!_tmp4_) {
		{
			GFileInfo* info = NULL;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp21_ = FALSE;
			_tmp5_ = file_exists;
			if (_tmp5_) {
				GFileInfo* _tmp6_ = NULL;
				GFile* _tmp7_ = NULL;
				GFileInfo* _tmp8_ = NULL;
				GFileInfo* _tmp9_ = NULL;
				_tmp7_ = file;
				_tmp8_ = g_file_query_info (_tmp7_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
				_tmp6_ = _tmp8_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (info);
					goto __catch46_g_error;
				}
				_tmp9_ = _tmp6_;
				_tmp6_ = NULL;
				_g_object_unref0 (info);
				info = _tmp9_;
				_g_object_unref0 (_tmp6_);
			} else {
				GFileInfo* _tmp10_ = NULL;
				GFile* _tmp11_ = NULL;
				GFile* _tmp12_ = NULL;
				GFile* _tmp13_ = NULL;
				GFileInfo* _tmp14_ = NULL;
				GFileInfo* _tmp15_ = NULL;
				GFileInfo* _tmp16_ = NULL;
				_tmp11_ = file;
				_tmp12_ = g_file_get_parent (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_file_query_info (_tmp13_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
				_tmp15_ = _tmp14_;
				_g_object_unref0 (_tmp13_);
				_tmp10_ = _tmp15_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (info);
					goto __catch46_g_error;
				}
				_tmp16_ = _tmp10_;
				_tmp10_ = NULL;
				_g_object_unref0 (info);
				info = _tmp16_;
				_g_object_unref0 (_tmp10_);
			}
			_tmp18_ = self->priv->read_only;
			if (_tmp18_) {
				_tmp17_ = TRUE;
			} else {
				GFileInfo* _tmp19_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp19_ = info;
				_tmp20_ = g_file_info_get_attribute_boolean (_tmp19_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
				_tmp17_ = !_tmp20_;
			}
			self->priv->read_only = _tmp17_;
			_tmp21_ = self->priv->read_only;
			if (_tmp21_) {
				gchar* _tmp22_ = NULL;
				GFile* _tmp23_ = NULL;
				gchar* _tmp24_ = NULL;
				_tmp23_ = file;
				_tmp24_ = g_file_get_path (_tmp23_);
				_tmp22_ = _tmp24_;
				if (_tmp22_ == NULL) {
					gchar* _tmp25_ = NULL;
					_tmp25_ = g_strdup ("");
					_g_free0 (_tmp22_);
					_tmp22_ = _tmp25_;
				}
				g_warning ("Preferences.vala:192: '%s' is read-only!", _tmp22_);
				_g_free0 (_tmp22_);
			}
			_g_object_unref0 (info);
		}
		goto __finally46;
		__catch46_g_error:
		{
			GError* e = NULL;
			GError* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp26_ = e;
			_tmp27_ = _tmp26_->message;
			g_warning ("Preferences.vala:194: %s", _tmp27_);
			self->priv->read_only = TRUE;
			_g_error_free0 (e);
		}
		__finally46:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp28_ = file_exists;
	if (!_tmp28_) {
		plank_preferences_save_prefs (self);
	} else {
		plank_preferences_load_prefs (self);
	}
	plank_preferences_start_monitor (self);
}


/**
 * Initializes this preferences with a backing filename.
 *
 * @param filename of the backing file for this preferences
 */
void plank_preferences_init_from_filename (PlankPreferences* self, const gchar* filename) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_tmp0_ = plank_paths_get_AppConfigFolder ();
	_tmp1_ = _tmp0_;
	_tmp2_ = filename;
	_tmp3_ = g_file_get_child (_tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	plank_preferences_init_from_file (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
}


/**
 * Delays saving changes to the backing file until apply() is called.
 */
void plank_preferences_delay (PlankPreferences* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->is_delayed;
	if (_tmp1_) {
		return;
	}
	_tmp3_ = self->priv->backing_file;
	if (_tmp3_ != NULL) {
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp4_ = self->priv->backing_file;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_ != NULL;
		_g_free0 (_tmp6_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GFile* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp7_ = self->priv->backing_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp9_ = _tmp8_;
		plank_logger_verbose ("Preferences.delay('%s')", _tmp9_, NULL);
		_g_free0 (_tmp9_);
	} else {
		plank_logger_verbose ("Preferences.delay()", NULL);
	}
	self->priv->is_delayed = TRUE;
}


/**
 * If any settings were changed, apply them now.
 */
void plank_preferences_apply (PlankPreferences* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->is_delayed;
	if (!_tmp1_) {
		return;
	}
	_tmp3_ = self->priv->backing_file;
	if (_tmp3_ != NULL) {
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp4_ = self->priv->backing_file;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_ != NULL;
		_g_free0 (_tmp6_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GFile* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp7_ = self->priv->backing_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp9_ = _tmp8_;
		plank_logger_verbose ("Preferences.apply('%s')", _tmp9_, NULL);
		_g_free0 (_tmp9_);
	} else {
		plank_logger_verbose ("Preferences.apply()", NULL);
	}
	self->priv->is_delayed = FALSE;
	_tmp11_ = self->priv->is_changed;
	if (_tmp11_) {
		GFile* _tmp12_ = NULL;
		_tmp12_ = self->priv->backing_file;
		_tmp10_ = _tmp12_ != NULL;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		plank_preferences_save_prefs (self);
	}
}


/**
 * Returns the filename of the backing file.
 *
 * @return the filename of the backing file
 */
gchar* plank_preferences_get_filename (PlankPreferences* self) {
	gchar* result = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->backing_file;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_strdup ("");
		result = _tmp1_;
		return result;
	}
	_tmp2_ = self->priv->backing_file;
	_tmp3_ = g_file_get_basename (_tmp2_);
	result = _tmp3_;
	return result;
}


/**
 * Returns the backing file.
 *
 * @return the backing file
 */
GFile* plank_preferences_get_backing_file (PlankPreferences* self) {
	GFile* result = NULL;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->backing_file;
	result = _tmp0_;
	return result;
}


/**
 * This forces the deletion of the backing file for this preferences.
 */
void plank_preferences_delete (PlankPreferences* self) {
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	self->priv->is_delayed = FALSE;
	self->priv->is_changed = FALSE;
	{
		gchar* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		_tmp2_ = self->priv->backing_file;
		_tmp3_ = g_file_get_path (_tmp2_);
		_tmp1_ = _tmp3_;
		if (_tmp1_ == NULL) {
			gchar* _tmp4_ = NULL;
			_tmp4_ = g_strdup ("");
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp4_;
		}
		_tmp5_ = _tmp1_;
		_tmp1_ = NULL;
		plank_logger_verbose ("Preferences.delete ('%s')", _tmp5_, NULL);
		_tmp6_ = self->priv->backing_file;
		g_file_delete (_tmp6_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (_tmp1_);
			goto __catch47_g_error;
		}
		_g_free0 (_tmp1_);
	}
	goto __finally47;
	__catch47_g_error:
	{
		GError* e = NULL;
		gchar* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = self->priv->backing_file;
		_tmp9_ = g_file_get_path (_tmp8_);
		_tmp7_ = _tmp9_;
		if (_tmp7_ == NULL) {
			gchar* _tmp10_ = NULL;
			_tmp10_ = g_strdup ("");
			_g_free0 (_tmp7_);
			_tmp7_ = _tmp10_;
		}
		g_warning ("Preferences.vala:300: Unable to delete the preferences file '%s'", _tmp7_);
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_debug ("Preferences.vala:301: %s", _tmp12_);
		_g_free0 (_tmp7_);
		_g_error_free0 (e);
	}
	__finally47:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _plank_preferences_backing_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
	plank_preferences_backing_file_changed (file, other_file, event_type, (PlankPreferences*) self);
}


static void plank_preferences_stop_monitor (PlankPreferences* self) {
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	GFileMonitor* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backing_monitor;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->backing_monitor;
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_preferences_backing_file_changed_g_file_monitor_changed, self);
	_tmp3_ = self->priv->backing_monitor;
	g_file_monitor_cancel (_tmp3_);
	_g_object_unref0 (self->priv->backing_monitor);
	self->priv->backing_monitor = NULL;
}


static void plank_preferences_start_monitor (PlankPreferences* self) {
	GFileMonitor* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backing_monitor;
	if (_tmp0_ != NULL) {
		return;
	}
	{
		GFileMonitor* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		GFileMonitor* _tmp3_ = NULL;
		GFileMonitor* _tmp4_ = NULL;
		GFileMonitor* _tmp5_ = NULL;
		_tmp2_ = self->priv->backing_file;
		_tmp3_ = g_file_monitor_file (_tmp2_, 0, NULL, &_inner_error_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch48_g_error;
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (self->priv->backing_monitor);
		self->priv->backing_monitor = _tmp4_;
		_tmp5_ = self->priv->backing_monitor;
		g_signal_connect_object (_tmp5_, "changed", (GCallback) _plank_preferences_backing_file_changed_g_file_monitor_changed, self, 0);
		_g_object_unref0 (_tmp1_);
	}
	goto __finally48;
	__catch48_g_error:
	{
		GError* e = NULL;
		gchar* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		GError* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = self->priv->backing_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp6_ = _tmp8_;
		if (_tmp6_ == NULL) {
			gchar* _tmp9_ = NULL;
			_tmp9_ = g_strdup ("");
			_g_free0 (_tmp6_);
			_tmp6_ = _tmp9_;
		}
		g_critical ("Preferences.vala:324: Unable to watch the preferences file '%s'", _tmp6_);
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_debug ("Preferences.vala:325: %s", _tmp11_);
		_g_free0 (_tmp6_);
		_g_error_free0 (e);
	}
	__finally48:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void plank_preferences_backing_file_changed (GFile* f, GFile* other, GFileMonitorEvent event, PlankPreferences* self) {
	GFileMonitorEvent _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (f != NULL);
	_tmp0_ = event;
	switch (_tmp0_) {
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
			plank_preferences_load_prefs (self);
			break;
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			GFile* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			_tmp1_ = f;
			_tmp2_ = g_file_query_exists (_tmp1_, NULL);
			if (!_tmp2_) {
				g_signal_emit_by_name (self, "deleted");
			}
			break;
		}
		default:
		{
			break;
		}
	}
}


static void plank_preferences_load_prefs (PlankPreferences* self) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* backing_file_path = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean missing_keys = FALSE;
	guint _tmp6_ = 0U;
	gboolean _tmp149_ = FALSE;
	gboolean _tmp150_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->backing_file;
	_tmp2_ = g_file_get_path (_tmp1_);
	_tmp0_ = _tmp2_;
	if (_tmp0_ == NULL) {
		gchar* _tmp3_ = NULL;
		_tmp3_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	backing_file_path = _tmp4_;
	_tmp5_ = backing_file_path;
	g_debug ("Preferences.vala:349: Loading preferences from file '%s'", _tmp5_);
	missing_keys = FALSE;
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp6_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_preferences_handle_notify_g_object_notify, self);
	g_object_freeze_notify ((GObject*) self);
	self->priv->is_delayed_internal = TRUE;
	{
		GKeyFile* file = NULL;
		GKeyFile* _tmp7_ = NULL;
		GKeyFile* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GParamSpec** properties = NULL;
		GObjectClass* _tmp10_ = NULL;
		guint _tmp11_;
		GParamSpec** _tmp12_ = NULL;
		gint properties_length1 = 0;
		gint _properties_size_ = 0;
		GParamSpec** _tmp13_ = NULL;
		gint _tmp13__length1 = 0;
		_tmp7_ = g_key_file_new ();
		file = _tmp7_;
		_tmp8_ = file;
		_tmp9_ = backing_file_path;
		g_key_file_load_from_file (_tmp8_, _tmp9_, 0, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_key_file_unref0 (file);
			goto __catch49_g_error;
		}
		_tmp10_ = G_OBJECT_GET_CLASS ((GObject*) self);
		_tmp12_ = g_object_class_list_properties (_tmp10_, &_tmp11_);
		properties = _tmp12_;
		properties_length1 = _tmp11_;
		_properties_size_ = properties_length1;
		_tmp13_ = properties;
		_tmp13__length1 = properties_length1;
		{
			GParamSpec** prop_collection = NULL;
			gint prop_collection_length1 = 0;
			gint _prop_collection_size_ = 0;
			gint prop_it = 0;
			prop_collection = _tmp13_;
			prop_collection_length1 = _tmp13__length1;
			for (prop_it = 0; prop_it < _tmp13__length1; prop_it = prop_it + 1) {
				GParamSpec* prop = NULL;
				prop = prop_collection[prop_it];
				{
					const gchar* group_name = NULL;
					GParamSpec* _tmp14_ = NULL;
					GType _tmp15_ = 0UL;
					const gchar* _tmp16_ = NULL;
					const gchar* prop_name = NULL;
					GParamSpec* _tmp17_ = NULL;
					const gchar* _tmp18_ = NULL;
					GKeyFile* _tmp19_ = NULL;
					const gchar* _tmp20_ = NULL;
					gboolean _tmp21_ = FALSE;
					gboolean _tmp32_ = FALSE;
					GKeyFile* _tmp33_ = NULL;
					const gchar* _tmp34_ = NULL;
					gboolean _tmp35_ = FALSE;
					GType type = 0UL;
					GParamSpec* _tmp44_ = NULL;
					GType _tmp45_ = 0UL;
					_tmp14_ = prop;
					_tmp15_ = _tmp14_->owner_type;
					_tmp16_ = g_type_name (_tmp15_);
					group_name = _tmp16_;
					_tmp17_ = prop;
					_tmp18_ = g_param_spec_get_name (_tmp17_);
					prop_name = _tmp18_;
					_tmp19_ = file;
					_tmp20_ = group_name;
					_tmp21_ = g_key_file_has_group (_tmp19_, _tmp20_);
					if (!_tmp21_) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp22_ = FALSE;
								_tmp22_ = TRUE;
								while (TRUE) {
									gint _tmp24_ = 0;
									gchar** _tmp25_ = NULL;
									gint _tmp25__length1 = 0;
									gint _tmp25__length2 = 0;
									gint _tmp26_ = 0;
									const gchar* _tmp27_ = NULL;
									const gchar* _tmp28_ = NULL;
									if (!_tmp22_) {
										gint _tmp23_ = 0;
										_tmp23_ = i;
										i = _tmp23_ + 1;
									}
									_tmp22_ = FALSE;
									_tmp24_ = i;
									if (!(_tmp24_ < 3)) {
										break;
									}
									_tmp25_ = plank_preferences_TRANSITION_MAP;
									_tmp25__length1 = plank_preferences_TRANSITION_MAP_length1;
									_tmp25__length2 = plank_preferences_TRANSITION_MAP_length2;
									_tmp26_ = i;
									_tmp27_ = _tmp25_[(_tmp26_ * _tmp25__length2) + 1];
									_tmp28_ = group_name;
									if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
										gchar** _tmp29_ = NULL;
										gint _tmp29__length1 = 0;
										gint _tmp29__length2 = 0;
										gint _tmp30_ = 0;
										const gchar* _tmp31_ = NULL;
										_tmp29_ = plank_preferences_TRANSITION_MAP;
										_tmp29__length1 = plank_preferences_TRANSITION_MAP_length1;
										_tmp29__length2 = plank_preferences_TRANSITION_MAP_length2;
										_tmp30_ = i;
										_tmp31_ = _tmp29_[(_tmp30_ * _tmp29__length2) + 0];
										group_name = _tmp31_;
										missing_keys = TRUE;
										break;
									}
								}
							}
						}
					}
					_tmp33_ = file;
					_tmp34_ = group_name;
					_tmp35_ = g_key_file_has_group (_tmp33_, _tmp34_);
					if (!_tmp35_) {
						_tmp32_ = TRUE;
					} else {
						gboolean _tmp36_ = FALSE;
						GKeyFile* _tmp37_ = NULL;
						const gchar* _tmp38_ = NULL;
						const gchar* _tmp39_ = NULL;
						gboolean _tmp40_ = FALSE;
						_tmp37_ = file;
						_tmp38_ = group_name;
						_tmp39_ = prop_name;
						_tmp40_ = g_key_file_has_key (_tmp37_, _tmp38_, _tmp39_, &_inner_error_);
						_tmp36_ = _tmp40_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							properties = (g_free (properties), NULL);
							_g_key_file_unref0 (file);
							goto __catch49_g_error;
						}
						_tmp32_ = !_tmp36_;
					}
					if (_tmp32_) {
						const gchar* _tmp41_ = NULL;
						const gchar* _tmp42_ = NULL;
						const gchar* _tmp43_ = NULL;
						_tmp41_ = prop_name;
						_tmp42_ = group_name;
						_tmp43_ = backing_file_path;
						g_warning ("Preferences.vala:382: Missing key '%s' for group '%s' in preferences f" \
"ile '%s' - using default value", _tmp41_, _tmp42_, _tmp43_);
						missing_keys = TRUE;
						continue;
					}
					_tmp44_ = prop;
					_tmp45_ = _tmp44_->value_type;
					type = _tmp45_;
					{
						GType _tmp46_ = 0UL;
						const gchar* _tmp141_ = NULL;
						_tmp46_ = type;
						if (_tmp46_ == G_TYPE_INT) {
							gint old_val = 0;
							const gchar* _tmp47_ = NULL;
							gint new_val = 0;
							GKeyFile* _tmp48_ = NULL;
							const gchar* _tmp49_ = NULL;
							const gchar* _tmp50_ = NULL;
							gint _tmp51_ = 0;
							gint _tmp52_ = 0;
							gint _tmp53_ = 0;
							const gchar* _tmp54_ = NULL;
							gint _tmp55_ = 0;
							_tmp47_ = prop_name;
							g_object_get ((GObject*) self, _tmp47_, &old_val, NULL);
							_tmp48_ = file;
							_tmp49_ = group_name;
							_tmp50_ = prop_name;
							_tmp51_ = g_key_file_get_integer (_tmp48_, _tmp49_, _tmp50_, &_inner_error_);
							new_val = _tmp51_;
							if (G_UNLIKELY (_inner_error_ != NULL)) {
								if (_inner_error_->domain == G_KEY_FILE_ERROR) {
									goto __catch50_g_key_file_error;
								}
								properties = (g_free (properties), NULL);
								_g_key_file_unref0 (file);
								_g_free0 (backing_file_path);
								_g_free0 (_tmp0_);
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
								g_clear_error (&_inner_error_);
								return;
							}
							_tmp52_ = old_val;
							_tmp53_ = new_val;
							if (_tmp52_ == _tmp53_) {
								continue;
							}
							_tmp54_ = prop_name;
							_tmp55_ = new_val;
							g_object_set ((GObject*) self, _tmp54_, _tmp55_, NULL);
						} else {
							GType _tmp56_ = 0UL;
							_tmp56_ = type;
							if (_tmp56_ == G_TYPE_UINT) {
								guint old_val = 0U;
								const gchar* _tmp57_ = NULL;
								gint _tmp58_ = 0;
								GKeyFile* _tmp59_ = NULL;
								const gchar* _tmp60_ = NULL;
								const gchar* _tmp61_ = NULL;
								gint _tmp62_ = 0;
								guint new_val = 0U;
								guint _tmp63_ = 0U;
								guint _tmp64_ = 0U;
								const gchar* _tmp65_ = NULL;
								guint _tmp66_ = 0U;
								_tmp57_ = prop_name;
								g_object_get ((GObject*) self, _tmp57_, &old_val, NULL);
								_tmp59_ = file;
								_tmp60_ = group_name;
								_tmp61_ = prop_name;
								_tmp62_ = g_key_file_get_integer (_tmp59_, _tmp60_, _tmp61_, &_inner_error_);
								_tmp58_ = _tmp62_;
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									if (_inner_error_->domain == G_KEY_FILE_ERROR) {
										goto __catch50_g_key_file_error;
									}
									properties = (g_free (properties), NULL);
									_g_key_file_unref0 (file);
									_g_free0 (backing_file_path);
									_g_free0 (_tmp0_);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return;
								}
								new_val = (guint) _tmp58_;
								_tmp63_ = old_val;
								_tmp64_ = new_val;
								if (_tmp63_ == _tmp64_) {
									continue;
								}
								_tmp65_ = prop_name;
								_tmp66_ = new_val;
								g_object_set ((GObject*) self, _tmp65_, _tmp66_, NULL);
							} else {
								GType _tmp67_ = 0UL;
								_tmp67_ = type;
								if (_tmp67_ == G_TYPE_DOUBLE) {
									gdouble old_val = 0.0;
									const gchar* _tmp68_ = NULL;
									gdouble new_val = 0.0;
									GKeyFile* _tmp69_ = NULL;
									const gchar* _tmp70_ = NULL;
									const gchar* _tmp71_ = NULL;
									gdouble _tmp72_ = 0.0;
									gdouble _tmp73_ = 0.0;
									gdouble _tmp74_ = 0.0;
									const gchar* _tmp75_ = NULL;
									gdouble _tmp76_ = 0.0;
									_tmp68_ = prop_name;
									g_object_get ((GObject*) self, _tmp68_, &old_val, NULL);
									_tmp69_ = file;
									_tmp70_ = group_name;
									_tmp71_ = prop_name;
									_tmp72_ = g_key_file_get_double (_tmp69_, _tmp70_, _tmp71_, &_inner_error_);
									new_val = _tmp72_;
									if (G_UNLIKELY (_inner_error_ != NULL)) {
										if (_inner_error_->domain == G_KEY_FILE_ERROR) {
											goto __catch50_g_key_file_error;
										}
										properties = (g_free (properties), NULL);
										_g_key_file_unref0 (file);
										_g_free0 (backing_file_path);
										_g_free0 (_tmp0_);
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return;
									}
									_tmp73_ = old_val;
									_tmp74_ = new_val;
									if (_tmp73_ == _tmp74_) {
										continue;
									}
									_tmp75_ = prop_name;
									_tmp76_ = new_val;
									g_object_set ((GObject*) self, _tmp75_, _tmp76_, NULL);
								} else {
									GType _tmp77_ = 0UL;
									_tmp77_ = type;
									if (_tmp77_ == G_TYPE_STRING) {
										gchar* old_val = NULL;
										const gchar* _tmp78_ = NULL;
										gchar* new_val = NULL;
										GKeyFile* _tmp79_ = NULL;
										const gchar* _tmp80_ = NULL;
										const gchar* _tmp81_ = NULL;
										gchar* _tmp82_ = NULL;
										const gchar* _tmp83_ = NULL;
										const gchar* _tmp84_ = NULL;
										const gchar* _tmp85_ = NULL;
										const gchar* _tmp86_ = NULL;
										_tmp78_ = prop_name;
										g_object_get ((GObject*) self, _tmp78_, &old_val, NULL);
										_tmp79_ = file;
										_tmp80_ = group_name;
										_tmp81_ = prop_name;
										_tmp82_ = g_key_file_get_string (_tmp79_, _tmp80_, _tmp81_, &_inner_error_);
										new_val = _tmp82_;
										if (G_UNLIKELY (_inner_error_ != NULL)) {
											_g_free0 (old_val);
											if (_inner_error_->domain == G_KEY_FILE_ERROR) {
												goto __catch50_g_key_file_error;
											}
											_g_free0 (old_val);
											properties = (g_free (properties), NULL);
											_g_key_file_unref0 (file);
											_g_free0 (backing_file_path);
											_g_free0 (_tmp0_);
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
											g_clear_error (&_inner_error_);
											return;
										}
										_tmp83_ = old_val;
										_tmp84_ = new_val;
										if (g_strcmp0 (_tmp83_, _tmp84_) == 0) {
											_g_free0 (new_val);
											_g_free0 (old_val);
											continue;
										}
										_tmp85_ = prop_name;
										_tmp86_ = new_val;
										g_object_set ((GObject*) self, _tmp85_, _tmp86_, NULL);
										_g_free0 (new_val);
										_g_free0 (old_val);
									} else {
										GType _tmp87_ = 0UL;
										_tmp87_ = type;
										if (_tmp87_ == G_TYPE_BOOLEAN) {
											gboolean old_val = FALSE;
											const gchar* _tmp88_ = NULL;
											gboolean new_val = FALSE;
											GKeyFile* _tmp89_ = NULL;
											const gchar* _tmp90_ = NULL;
											const gchar* _tmp91_ = NULL;
											gboolean _tmp92_ = FALSE;
											gboolean _tmp93_ = FALSE;
											gboolean _tmp94_ = FALSE;
											const gchar* _tmp95_ = NULL;
											gboolean _tmp96_ = FALSE;
											_tmp88_ = prop_name;
											g_object_get ((GObject*) self, _tmp88_, &old_val, NULL);
											_tmp89_ = file;
											_tmp90_ = group_name;
											_tmp91_ = prop_name;
											_tmp92_ = g_key_file_get_boolean (_tmp89_, _tmp90_, _tmp91_, &_inner_error_);
											new_val = _tmp92_;
											if (G_UNLIKELY (_inner_error_ != NULL)) {
												if (_inner_error_->domain == G_KEY_FILE_ERROR) {
													goto __catch50_g_key_file_error;
												}
												properties = (g_free (properties), NULL);
												_g_key_file_unref0 (file);
												_g_free0 (backing_file_path);
												_g_free0 (_tmp0_);
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
												g_clear_error (&_inner_error_);
												return;
											}
											_tmp93_ = old_val;
											_tmp94_ = new_val;
											if (_tmp93_ == _tmp94_) {
												continue;
											}
											_tmp95_ = prop_name;
											_tmp96_ = new_val;
											g_object_set ((GObject*) self, _tmp95_, _tmp96_, NULL);
										} else {
											GType _tmp97_ = 0UL;
											gboolean _tmp98_ = FALSE;
											_tmp97_ = type;
											_tmp98_ = G_TYPE_IS_ENUM (_tmp97_);
											if (_tmp98_) {
												gint old_val = 0;
												const gchar* _tmp99_ = NULL;
												gint new_val = 0;
												GKeyFile* _tmp100_ = NULL;
												const gchar* _tmp101_ = NULL;
												const gchar* _tmp102_ = NULL;
												gint _tmp103_ = 0;
												gint _tmp104_ = 0;
												gint _tmp105_ = 0;
												const gchar* _tmp106_ = NULL;
												gint _tmp107_ = 0;
												_tmp99_ = prop_name;
												g_object_get ((GObject*) self, _tmp99_, &old_val, NULL);
												_tmp100_ = file;
												_tmp101_ = group_name;
												_tmp102_ = prop_name;
												_tmp103_ = g_key_file_get_integer (_tmp100_, _tmp101_, _tmp102_, &_inner_error_);
												new_val = _tmp103_;
												if (G_UNLIKELY (_inner_error_ != NULL)) {
													if (_inner_error_->domain == G_KEY_FILE_ERROR) {
														goto __catch50_g_key_file_error;
													}
													properties = (g_free (properties), NULL);
													_g_key_file_unref0 (file);
													_g_free0 (backing_file_path);
													_g_free0 (_tmp0_);
													g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
													g_clear_error (&_inner_error_);
													return;
												}
												_tmp104_ = old_val;
												_tmp105_ = new_val;
												if (_tmp104_ == _tmp105_) {
													continue;
												}
												_tmp106_ = prop_name;
												_tmp107_ = new_val;
												g_object_set ((GObject*) self, _tmp106_, _tmp107_, NULL);
											} else {
												gboolean _tmp108_ = FALSE;
												GType _tmp109_ = 0UL;
												gboolean _tmp110_ = FALSE;
												_tmp109_ = type;
												_tmp110_ = g_type_is_a (_tmp109_, PLANK_TYPE_COLOR);
												if (_tmp110_) {
													_tmp108_ = TRUE;
												} else {
													GType _tmp111_ = 0UL;
													gboolean _tmp112_ = FALSE;
													_tmp111_ = type;
													_tmp112_ = g_type_is_a (_tmp111_, gdk_rgba_get_type ());
													_tmp108_ = _tmp112_;
												}
												if (_tmp108_) {
													GValue val = {0};
													GType _tmp113_ = 0UL;
													GValue _tmp114_ = {0};
													const gchar* _tmp115_ = NULL;
													PlankColor* old_val = NULL;
													void* _tmp116_ = NULL;
													gchar* old_val_string = NULL;
													gchar* _tmp117_ = NULL;
													gchar* new_val_string = NULL;
													GKeyFile* _tmp118_ = NULL;
													const gchar* _tmp119_ = NULL;
													const gchar* _tmp120_ = NULL;
													gchar* _tmp121_ = NULL;
													const gchar* _tmp122_ = NULL;
													const gchar* _tmp123_ = NULL;
													PlankColor new_val = {0};
													const gchar* _tmp124_ = NULL;
													PlankColor _tmp125_ = {0};
													const gchar* _tmp126_ = NULL;
													GValue _tmp127_ = {0};
													_tmp113_ = type;
													g_value_init (&_tmp114_, _tmp113_);
													val = _tmp114_;
													_tmp115_ = prop_name;
													g_object_get_property ((GObject*) self, _tmp115_, &val);
													_tmp116_ = g_value_get_boxed (&val);
													old_val = _tmp116_;
													_tmp117_ = plank_color_to_prefs_string (old_val);
													old_val_string = _tmp117_;
													_tmp118_ = file;
													_tmp119_ = group_name;
													_tmp120_ = prop_name;
													_tmp121_ = g_key_file_get_string (_tmp118_, _tmp119_, _tmp120_, &_inner_error_);
													new_val_string = _tmp121_;
													if (G_UNLIKELY (_inner_error_ != NULL)) {
														_g_free0 (old_val_string);
														G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
														if (_inner_error_->domain == G_KEY_FILE_ERROR) {
															goto __catch50_g_key_file_error;
														}
														_g_free0 (old_val_string);
														G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
														properties = (g_free (properties), NULL);
														_g_key_file_unref0 (file);
														_g_free0 (backing_file_path);
														_g_free0 (_tmp0_);
														g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
														g_clear_error (&_inner_error_);
														return;
													}
													_tmp122_ = old_val_string;
													_tmp123_ = new_val_string;
													if (g_strcmp0 (_tmp122_, _tmp123_) == 0) {
														_g_free0 (new_val_string);
														_g_free0 (old_val_string);
														G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
														continue;
													}
													_tmp124_ = new_val_string;
													plank_color_from_prefs_string (_tmp124_, &_tmp125_);
													new_val = _tmp125_;
													g_value_set_boxed (&val, &new_val);
													_tmp126_ = prop_name;
													_tmp127_ = val;
													g_object_set_property ((GObject*) self, _tmp126_, &_tmp127_);
													_g_free0 (new_val_string);
													_g_free0 (old_val_string);
													G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
												} else {
													GType _tmp128_ = 0UL;
													gboolean _tmp129_ = FALSE;
													_tmp128_ = type;
													_tmp129_ = g_type_is_a (_tmp128_, PLANK_TYPE_SERIALIZABLE);
													if (_tmp129_) {
														PlankSerializable* val = NULL;
														const gchar* _tmp130_ = NULL;
														gchar* _tmp131_ = NULL;
														GKeyFile* _tmp132_ = NULL;
														const gchar* _tmp133_ = NULL;
														const gchar* _tmp134_ = NULL;
														gchar* _tmp135_ = NULL;
														PlankSerializable* _tmp136_ = NULL;
														_tmp130_ = prop_name;
														g_object_get ((GObject*) self, _tmp130_, &val, NULL);
														_tmp132_ = file;
														_tmp133_ = group_name;
														_tmp134_ = prop_name;
														_tmp135_ = g_key_file_get_string (_tmp132_, _tmp133_, _tmp134_, &_inner_error_);
														_tmp131_ = _tmp135_;
														if (G_UNLIKELY (_inner_error_ != NULL)) {
															_g_object_unref0 (val);
															if (_inner_error_->domain == G_KEY_FILE_ERROR) {
																goto __catch50_g_key_file_error;
															}
															_g_object_unref0 (val);
															properties = (g_free (properties), NULL);
															_g_key_file_unref0 (file);
															_g_free0 (backing_file_path);
															_g_free0 (_tmp0_);
															g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
															g_clear_error (&_inner_error_);
															return;
														}
														_tmp136_ = val;
														plank_serializable_deserialize (_tmp136_, _tmp131_);
														_g_free0 (_tmp131_);
														_g_object_unref0 (val);
														continue;
													} else {
														GType _tmp137_ = 0UL;
														const gchar* _tmp138_ = NULL;
														const gchar* _tmp139_ = NULL;
														const gchar* _tmp140_ = NULL;
														_tmp137_ = type;
														_tmp138_ = g_type_name (_tmp137_);
														_tmp139_ = prop_name;
														_tmp140_ = backing_file_path;
														g_debug ("Preferences.vala:449: Unsupported preferences type '%s' for property '" \
"%s' in file '%s'", _tmp138_, _tmp139_, _tmp140_);
														continue;
													}
												}
											}
										}
									}
								}
							}
						}
						_tmp141_ = prop_name;
						plank_preferences_call_verify (self, _tmp141_);
					}
					goto __finally50;
					__catch50_g_key_file_error:
					{
						GError* e = NULL;
						const gchar* _tmp142_ = NULL;
						const gchar* _tmp143_ = NULL;
						GError* _tmp144_ = NULL;
						const gchar* _tmp145_ = NULL;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp142_ = backing_file_path;
						_tmp143_ = prop_name;
						g_warning ("Preferences.vala:455: Problem loading preferences from file '%s' for p" \
"roperty '%s'", _tmp142_, _tmp143_);
						_tmp144_ = e;
						_tmp145_ = _tmp144_->message;
						g_debug ("Preferences.vala:456: %s", _tmp145_);
						_g_error_free0 (e);
					}
					__finally50:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						properties = (g_free (properties), NULL);
						_g_key_file_unref0 (file);
						goto __catch49_g_error;
					}
				}
			}
		}
		properties = (g_free (properties), NULL);
		_g_key_file_unref0 (file);
	}
	goto __finally49;
	__catch49_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp146_ = NULL;
		GError* _tmp147_ = NULL;
		const gchar* _tmp148_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp146_ = backing_file_path;
		g_warning ("Preferences.vala:460: Unable to load preferences from file '%s'", _tmp146_);
		_tmp147_ = e;
		_tmp148_ = _tmp147_->message;
		g_debug ("Preferences.vala:461: %s", _tmp148_);
		g_signal_emit_by_name (self, "deleted");
		_g_error_free0 (e);
	}
	__finally49:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (backing_file_path);
		_g_free0 (_tmp0_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_object_thaw_notify ((GObject*) self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_notify_g_object_notify, self, 0);
	self->priv->is_delayed_internal = FALSE;
	_tmp150_ = missing_keys;
	if (_tmp150_) {
		_tmp149_ = TRUE;
	} else {
		gboolean _tmp151_ = FALSE;
		gboolean _tmp152_ = FALSE;
		gboolean _tmp153_ = FALSE;
		_tmp153_ = self->priv->is_delayed;
		if (!_tmp153_) {
			gboolean _tmp154_ = FALSE;
			_tmp154_ = self->priv->is_changed;
			_tmp152_ = _tmp154_;
		} else {
			_tmp152_ = FALSE;
		}
		if (_tmp152_) {
			GFile* _tmp155_ = NULL;
			_tmp155_ = self->priv->backing_file;
			_tmp151_ = _tmp155_ != NULL;
		} else {
			_tmp151_ = FALSE;
		}
		_tmp149_ = _tmp151_;
	}
	if (_tmp149_) {
		plank_preferences_save_prefs (self);
	}
	_g_free0 (backing_file_path);
	_g_free0 (_tmp0_);
}


static gchar* g_date_time_to_string (GDateTime* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}


static void plank_preferences_save_prefs (PlankPreferences* self) {
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* backing_file_path = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GKeyFile* file = NULL;
	GKeyFile* _tmp11_ = NULL;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp19_ = NULL;
	guint _tmp20_;
	GParamSpec** _tmp21_ = NULL;
	gint properties_length1 = 0;
	gint _properties_size_ = 0;
	GParamSpec** _tmp22_ = NULL;
	gint _tmp22__length1 = 0;
	const gchar* _tmp108_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backing_file;
	_vala_return_if_fail (_tmp0_ != NULL, "backing_file != null");
	_tmp1_ = self->priv->read_only;
	if (_tmp1_) {
		return;
	}
	_tmp3_ = self->priv->backing_file;
	_tmp4_ = g_file_get_path (_tmp3_);
	_tmp2_ = _tmp4_;
	if (_tmp2_ == NULL) {
		gchar* _tmp5_ = NULL;
		_tmp5_ = g_strdup ("");
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp5_;
	}
	_tmp6_ = _tmp2_;
	_tmp2_ = NULL;
	backing_file_path = _tmp6_;
	_tmp8_ = self->priv->is_delayed;
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		gboolean _tmp9_ = FALSE;
		_tmp9_ = self->priv->is_delayed_internal;
		_tmp7_ = _tmp9_;
	}
	if (_tmp7_) {
		const gchar* _tmp10_ = NULL;
		_tmp10_ = backing_file_path;
		plank_logger_verbose ("Preferences.save_prefs('%s') - delaying save", _tmp10_, NULL);
		self->priv->is_changed = TRUE;
		_g_free0 (backing_file_path);
		_g_free0 (_tmp2_);
		return;
	}
	plank_preferences_stop_monitor (self);
	g_object_freeze_notify ((GObject*) self);
	_tmp11_ = g_key_file_new ();
	file = _tmp11_;
	{
		GKeyFile* _tmp12_ = NULL;
		GDateTime* _tmp13_ = NULL;
		GDateTime* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		_tmp12_ = file;
		_tmp13_ = g_date_time_new_now_utc ();
		_tmp14_ = _tmp13_;
		_tmp15_ = g_date_time_to_string (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = g_strdup_printf ("This file auto-generated by Plank.\n%s", _tmp16_);
		_tmp18_ = _tmp17_;
		g_key_file_set_comment (_tmp12_, NULL, NULL, _tmp18_, &_inner_error_);
		_g_free0 (_tmp18_);
		_g_free0 (_tmp16_);
		_g_date_time_unref0 (_tmp14_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch51_g_error;
		}
	}
	goto __finally51;
	__catch51_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally51:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_key_file_unref0 (file);
		_g_free0 (backing_file_path);
		_g_free0 (_tmp2_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp19_ = G_OBJECT_GET_CLASS ((GObject*) self);
	_tmp21_ = g_object_class_list_properties (_tmp19_, &_tmp20_);
	properties = _tmp21_;
	properties_length1 = _tmp20_;
	_properties_size_ = properties_length1;
	_tmp22_ = properties;
	_tmp22__length1 = properties_length1;
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
		prop_collection = _tmp22_;
		prop_collection_length1 = _tmp22__length1;
		for (prop_it = 0; prop_it < _tmp22__length1; prop_it = prop_it + 1) {
			GParamSpec* prop = NULL;
			prop = prop_collection[prop_it];
			{
				const gchar* group_name = NULL;
				GParamSpec* _tmp23_ = NULL;
				GType _tmp24_ = 0UL;
				const gchar* _tmp25_ = NULL;
				const gchar* prop_name = NULL;
				GParamSpec* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
				GType type = 0UL;
				GParamSpec* _tmp28_ = NULL;
				GType _tmp29_ = 0UL;
				GType _tmp30_ = 0UL;
				const gchar* prop_blurb = NULL;
				GParamSpec* _tmp96_ = NULL;
				const gchar* _tmp97_ = NULL;
				gboolean _tmp98_ = FALSE;
				gboolean _tmp99_ = FALSE;
				const gchar* _tmp100_ = NULL;
				_tmp23_ = prop;
				_tmp24_ = _tmp23_->owner_type;
				_tmp25_ = g_type_name (_tmp24_);
				group_name = _tmp25_;
				_tmp26_ = prop;
				_tmp27_ = g_param_spec_get_name (_tmp26_);
				prop_name = _tmp27_;
				_tmp28_ = prop;
				_tmp29_ = _tmp28_->value_type;
				type = _tmp29_;
				_tmp30_ = type;
				if (_tmp30_ == G_TYPE_INT) {
					gint new_val = 0;
					const gchar* _tmp31_ = NULL;
					GKeyFile* _tmp32_ = NULL;
					const gchar* _tmp33_ = NULL;
					const gchar* _tmp34_ = NULL;
					gint _tmp35_ = 0;
					_tmp31_ = prop_name;
					g_object_get ((GObject*) self, _tmp31_, &new_val, NULL);
					_tmp32_ = file;
					_tmp33_ = group_name;
					_tmp34_ = prop_name;
					_tmp35_ = new_val;
					g_key_file_set_integer (_tmp32_, _tmp33_, _tmp34_, _tmp35_);
				} else {
					GType _tmp36_ = 0UL;
					_tmp36_ = type;
					if (_tmp36_ == G_TYPE_UINT) {
						guint new_val = 0U;
						const gchar* _tmp37_ = NULL;
						GKeyFile* _tmp38_ = NULL;
						const gchar* _tmp39_ = NULL;
						const gchar* _tmp40_ = NULL;
						guint _tmp41_ = 0U;
						_tmp37_ = prop_name;
						g_object_get ((GObject*) self, _tmp37_, &new_val, NULL);
						_tmp38_ = file;
						_tmp39_ = group_name;
						_tmp40_ = prop_name;
						_tmp41_ = new_val;
						g_key_file_set_integer (_tmp38_, _tmp39_, _tmp40_, (gint) _tmp41_);
					} else {
						GType _tmp42_ = 0UL;
						_tmp42_ = type;
						if (_tmp42_ == G_TYPE_DOUBLE) {
							gdouble new_val = 0.0;
							const gchar* _tmp43_ = NULL;
							GKeyFile* _tmp44_ = NULL;
							const gchar* _tmp45_ = NULL;
							const gchar* _tmp46_ = NULL;
							gdouble _tmp47_ = 0.0;
							_tmp43_ = prop_name;
							g_object_get ((GObject*) self, _tmp43_, &new_val, NULL);
							_tmp44_ = file;
							_tmp45_ = group_name;
							_tmp46_ = prop_name;
							_tmp47_ = new_val;
							g_key_file_set_double (_tmp44_, _tmp45_, _tmp46_, _tmp47_);
						} else {
							GType _tmp48_ = 0UL;
							_tmp48_ = type;
							if (_tmp48_ == G_TYPE_STRING) {
								gchar* new_val = NULL;
								const gchar* _tmp49_ = NULL;
								GKeyFile* _tmp50_ = NULL;
								const gchar* _tmp51_ = NULL;
								const gchar* _tmp52_ = NULL;
								const gchar* _tmp53_ = NULL;
								_tmp49_ = prop_name;
								g_object_get ((GObject*) self, _tmp49_, &new_val, NULL);
								_tmp50_ = file;
								_tmp51_ = group_name;
								_tmp52_ = prop_name;
								_tmp53_ = new_val;
								g_key_file_set_string (_tmp50_, _tmp51_, _tmp52_, _tmp53_);
								_g_free0 (new_val);
							} else {
								GType _tmp54_ = 0UL;
								_tmp54_ = type;
								if (_tmp54_ == G_TYPE_BOOLEAN) {
									gboolean new_val = FALSE;
									const gchar* _tmp55_ = NULL;
									GKeyFile* _tmp56_ = NULL;
									const gchar* _tmp57_ = NULL;
									const gchar* _tmp58_ = NULL;
									gboolean _tmp59_ = FALSE;
									_tmp55_ = prop_name;
									g_object_get ((GObject*) self, _tmp55_, &new_val, NULL);
									_tmp56_ = file;
									_tmp57_ = group_name;
									_tmp58_ = prop_name;
									_tmp59_ = new_val;
									g_key_file_set_boolean (_tmp56_, _tmp57_, _tmp58_, _tmp59_);
								} else {
									GType _tmp60_ = 0UL;
									gboolean _tmp61_ = FALSE;
									_tmp60_ = type;
									_tmp61_ = G_TYPE_IS_ENUM (_tmp60_);
									if (_tmp61_) {
										gint new_val = 0;
										const gchar* _tmp62_ = NULL;
										GKeyFile* _tmp63_ = NULL;
										const gchar* _tmp64_ = NULL;
										const gchar* _tmp65_ = NULL;
										gint _tmp66_ = 0;
										_tmp62_ = prop_name;
										g_object_get ((GObject*) self, _tmp62_, &new_val, NULL);
										_tmp63_ = file;
										_tmp64_ = group_name;
										_tmp65_ = prop_name;
										_tmp66_ = new_val;
										g_key_file_set_integer (_tmp63_, _tmp64_, _tmp65_, _tmp66_);
									} else {
										gboolean _tmp67_ = FALSE;
										GType _tmp68_ = 0UL;
										gboolean _tmp69_ = FALSE;
										_tmp68_ = type;
										_tmp69_ = g_type_is_a (_tmp68_, PLANK_TYPE_COLOR);
										if (_tmp69_) {
											_tmp67_ = TRUE;
										} else {
											GType _tmp70_ = 0UL;
											gboolean _tmp71_ = FALSE;
											_tmp70_ = type;
											_tmp71_ = g_type_is_a (_tmp70_, gdk_rgba_get_type ());
											_tmp67_ = _tmp71_;
										}
										if (_tmp67_) {
											GValue val = {0};
											GType _tmp72_ = 0UL;
											GValue _tmp73_ = {0};
											const gchar* _tmp74_ = NULL;
											PlankColor* color = NULL;
											void* _tmp75_ = NULL;
											GKeyFile* _tmp76_ = NULL;
											const gchar* _tmp77_ = NULL;
											const gchar* _tmp78_ = NULL;
											gchar* _tmp79_ = NULL;
											gchar* _tmp80_ = NULL;
											_tmp72_ = type;
											g_value_init (&_tmp73_, _tmp72_);
											val = _tmp73_;
											_tmp74_ = prop_name;
											g_object_get_property ((GObject*) self, _tmp74_, &val);
											_tmp75_ = g_value_get_boxed (&val);
											color = _tmp75_;
											_tmp76_ = file;
											_tmp77_ = group_name;
											_tmp78_ = prop_name;
											_tmp79_ = plank_color_to_prefs_string (color);
											_tmp80_ = _tmp79_;
											g_key_file_set_string (_tmp76_, _tmp77_, _tmp78_, _tmp80_);
											_g_free0 (_tmp80_);
											G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
										} else {
											GType _tmp81_ = 0UL;
											gboolean _tmp82_ = FALSE;
											_tmp81_ = type;
											_tmp82_ = g_type_is_a (_tmp81_, PLANK_TYPE_SERIALIZABLE);
											if (_tmp82_) {
												GValue val = {0};
												GType _tmp83_ = 0UL;
												GValue _tmp84_ = {0};
												const gchar* _tmp85_ = NULL;
												GKeyFile* _tmp86_ = NULL;
												const gchar* _tmp87_ = NULL;
												const gchar* _tmp88_ = NULL;
												GObject* _tmp89_ = NULL;
												gchar* _tmp90_ = NULL;
												gchar* _tmp91_ = NULL;
												_tmp83_ = type;
												g_value_init (&_tmp84_, _tmp83_);
												val = _tmp84_;
												_tmp85_ = prop_name;
												g_object_get_property ((GObject*) self, _tmp85_, &val);
												_tmp86_ = file;
												_tmp87_ = group_name;
												_tmp88_ = prop_name;
												_tmp89_ = g_value_get_object (&val);
												_tmp90_ = plank_serializable_serialize (G_TYPE_CHECK_INSTANCE_CAST (_tmp89_, PLANK_TYPE_SERIALIZABLE, PlankSerializable));
												_tmp91_ = _tmp90_;
												g_key_file_set_string (_tmp86_, _tmp87_, _tmp88_, _tmp91_);
												_g_free0 (_tmp91_);
												G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
											} else {
												GType _tmp92_ = 0UL;
												const gchar* _tmp93_ = NULL;
												const gchar* _tmp94_ = NULL;
												const gchar* _tmp95_ = NULL;
												_tmp92_ = type;
												_tmp93_ = g_type_name (_tmp92_);
												_tmp94_ = prop_name;
												_tmp95_ = backing_file_path;
												g_debug ("Preferences.vala:542: Unsupported preferences type '%s' for property '" \
"%s' in file '%s'", _tmp93_, _tmp94_, _tmp95_);
												continue;
											}
										}
									}
								}
							}
						}
					}
				}
				_tmp96_ = prop;
				_tmp97_ = g_param_spec_get_blurb (_tmp96_);
				prop_blurb = _tmp97_;
				_tmp100_ = prop_blurb;
				if (_tmp100_ != NULL) {
					const gchar* _tmp101_ = NULL;
					_tmp101_ = prop_blurb;
					_tmp99_ = g_strcmp0 (_tmp101_, "") != 0;
				} else {
					_tmp99_ = FALSE;
				}
				if (_tmp99_) {
					const gchar* _tmp102_ = NULL;
					const gchar* _tmp103_ = NULL;
					_tmp102_ = prop_blurb;
					_tmp103_ = prop_name;
					_tmp98_ = g_strcmp0 (_tmp102_, _tmp103_) != 0;
				} else {
					_tmp98_ = FALSE;
				}
				if (_tmp98_) {
					{
						GKeyFile* _tmp104_ = NULL;
						const gchar* _tmp105_ = NULL;
						const gchar* _tmp106_ = NULL;
						const gchar* _tmp107_ = NULL;
						_tmp104_ = file;
						_tmp105_ = group_name;
						_tmp106_ = prop_name;
						_tmp107_ = prop_blurb;
						g_key_file_set_comment (_tmp104_, _tmp105_, _tmp106_, _tmp107_, &_inner_error_);
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							goto __catch52_g_error;
						}
					}
					goto __finally52;
					__catch52_g_error:
					{
						g_clear_error (&_inner_error_);
						_inner_error_ = NULL;
					}
					__finally52:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						properties = (g_free (properties), NULL);
						_g_key_file_unref0 (file);
						_g_free0 (backing_file_path);
						_g_free0 (_tmp2_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
			}
		}
	}
	_tmp108_ = backing_file_path;
	g_debug ("Preferences.vala:553: Saving preferences '%s'", _tmp108_);
	self->priv->is_changed = FALSE;
	{
		GFileOutputStream* _tmp109_ = NULL;
		GFile* _tmp110_ = NULL;
		GFileOutputStream* _tmp111_ = NULL;
		GDataOutputStream* stream = NULL;
		GDataOutputStream* _tmp112_ = NULL;
		GDataOutputStream* _tmp113_ = NULL;
		GKeyFile* _tmp114_ = NULL;
		gchar* _tmp115_ = NULL;
		gchar* _tmp116_ = NULL;
		GDataOutputStream* _tmp117_ = NULL;
		_tmp110_ = self->priv->backing_file;
		_tmp111_ = g_file_replace (_tmp110_, NULL, FALSE, 0, NULL, &_inner_error_);
		_tmp109_ = _tmp111_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch53_g_error;
		}
		_tmp112_ = g_data_output_stream_new ((GOutputStream*) _tmp109_);
		stream = _tmp112_;
		_tmp113_ = stream;
		_tmp114_ = file;
		_tmp115_ = g_key_file_to_data (_tmp114_, NULL, NULL);
		_tmp116_ = _tmp115_;
		g_data_output_stream_put_string (_tmp113_, _tmp116_, NULL, &_inner_error_);
		_g_free0 (_tmp116_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (stream);
			_g_object_unref0 (_tmp109_);
			goto __catch53_g_error;
		}
		_tmp117_ = stream;
		g_output_stream_close ((GOutputStream*) _tmp117_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (stream);
			_g_object_unref0 (_tmp109_);
			goto __catch53_g_error;
		}
		_g_object_unref0 (stream);
		_g_object_unref0 (_tmp109_);
	}
	goto __finally53;
	__catch53_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp118_ = NULL;
		GError* _tmp119_ = NULL;
		const gchar* _tmp120_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp118_ = backing_file_path;
		g_warning ("Preferences.vala:561: Unable to create the preferences file '%s'", _tmp118_);
		_tmp119_ = e;
		_tmp120_ = _tmp119_->message;
		g_debug ("Preferences.vala:562: %s", _tmp120_);
		_g_error_free0 (e);
	}
	__finally53:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		properties = (g_free (properties), NULL);
		_g_key_file_unref0 (file);
		_g_free0 (backing_file_path);
		_g_free0 (_tmp2_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_object_thaw_notify ((GObject*) self);
	plank_preferences_start_monitor (self);
	properties = (g_free (properties), NULL);
	_g_key_file_unref0 (file);
	_g_free0 (backing_file_path);
	_g_free0 (_tmp2_);
}


static GObject * plank_preferences_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankPreferences * self;
	parent_class = G_OBJECT_CLASS (plank_preferences_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES, PlankPreferences);
	plank_preferences_reset_properties (self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_notify_g_object_notify, self, 0);
	return obj;
}


static void plank_preferences_class_init (PlankPreferencesClass * klass) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_ = NULL;
	plank_preferences_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankPreferencesPrivate));
	((PlankPreferencesClass *) klass)->verify = (void (*)(PlankPreferences*, const gchar*)) plank_preferences_real_verify;
	((PlankPreferencesClass *) klass)->reset_properties = (void (*)(PlankPreferences*)) plank_preferences_real_reset_properties;
	G_OBJECT_CLASS (klass)->constructor = plank_preferences_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_preferences_finalize;
	/**
	 * This signal indicates that the backing file for this preferences was deleted.
	 */
	g_signal_new ("deleted", PLANK_TYPE_PREFERENCES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = g_strdup ("PlankItemsDockItemPreferences");
	_tmp1_ = g_strdup ("PlankDockItemPreferences");
	_tmp2_ = g_strdup ("PlankDrawingTheme");
	_tmp3_ = g_strdup ("PlankTheme");
	_tmp4_ = g_strdup ("PlankDrawingDockTheme");
	_tmp5_ = g_strdup ("PlankDockTheme");
	_tmp6_ = g_new0 (gchar*, (3 * 2) + 1);
	_tmp6_[0] = _tmp0_;
	_tmp6_[1] = _tmp1_;
	_tmp6_[2] = _tmp2_;
	_tmp6_[3] = _tmp3_;
	_tmp6_[4] = _tmp4_;
	_tmp6_[5] = _tmp5_;
	plank_preferences_TRANSITION_MAP = _tmp6_;
	plank_preferences_TRANSITION_MAP_length1 = 3;
	plank_preferences_TRANSITION_MAP_length2 = 2;
}


static void plank_preferences_instance_init (PlankPreferences * self) {
	self->priv = PLANK_PREFERENCES_GET_PRIVATE (self);
	self->priv->read_only = FALSE;
	self->priv->is_delayed = FALSE;
	self->priv->is_delayed_internal = FALSE;
	self->priv->is_changed = FALSE;
}


static void plank_preferences_finalize (GObject* obj) {
	PlankPreferences * self;
	guint _tmp0_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES, PlankPreferences);
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _plank_preferences_handle_notify_g_object_notify, self);
	plank_preferences_apply (self);
	plank_preferences_stop_monitor (self);
	_g_object_unref0 (self->priv->backing_file);
	_g_object_unref0 (self->priv->backing_monitor);
	G_OBJECT_CLASS (plank_preferences_parent_class)->finalize (obj);
}


/**
 * The base class for all preferences in the system.  Preferences are serialized to files.
 * The file is watched for changes and loads new values if the backing file changed.  When
 * any public property of a sub-class is changed, the public properties are serialized to
 * the backing file.
 */
GType plank_preferences_get_type (void) {
	static volatile gsize plank_preferences_type_id__volatile = 0;
	if (g_once_init_enter (&plank_preferences_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankPreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankPreferences), 0, (GInstanceInitFunc) plank_preferences_instance_init, NULL };
		GType plank_preferences_type_id;
		plank_preferences_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankPreferences", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&plank_preferences_type_id__volatile, plank_preferences_type_id);
	}
	return plank_preferences_type_id__volatile;
}



